<?php
/**
 * Digital Marketer functions and definitions
 *
 * @package Digital Marketer
 */

if ( ! defined( 'DIGITAL_MARKETER_VERSION' ) ) {
	// Replace the version number of the theme on each release.
	define( 'DIGITAL_MARKETER_VERSION', '1.0.0' );
}

function digital_marketer_setup() {

	load_theme_textdomain( 'digital-marketer', get_template_directory() . '/languages' );
	add_theme_support( 'automatic-feed-links' );
	add_theme_support( 'title-tag' );
	add_theme_support( 'post-thumbnails' );
	add_theme_support( 'woocommerce' );
	add_theme_support( "align-wide" );
	add_theme_support( "responsive-embeds" );

	register_nav_menus(
		array(
			'menu-1' => esc_html__( 'Primary', 'digital-marketer' ),
			'social-menu' => esc_html__('Social Menu', 'digital-marketer'),
		)
	);

	add_theme_support(
		'html5',
		array(
			'search-form',
			'comment-form',
			'comment-list',
			'gallery',
			'caption',
			'style',
			'script',
		)
	);

	add_theme_support(
		'custom-background',
		apply_filters(
			'digital_marketer_custom_background_args',
			array(
				'default-color' => '#fafafa',
				'default-image' => '',
			)
		)
	);

	add_theme_support( 'customize-selective-refresh-widgets' );

	add_theme_support(
		'custom-logo',
		array(
			'height'      => 250,
			'width'       => 250,
			'flex-width'  => true,
			'flex-height' => true,
		)
	);

	add_theme_support( 'post-formats', array(
        'image',
        'video',
        'gallery',
        'audio', 
    ));
	
}
add_action( 'after_setup_theme', 'digital_marketer_setup' );

/**
 * Set the content width in pixels, based on the theme's design and stylesheet.
 *
 * Priority 0 to make it available to lower priority callbacks.
 *
 * @global int $content_width
 */
function digital_marketer_content_width() {
	$GLOBALS['content_width'] = apply_filters( 'digital_marketer_content_width', 640 );
}
add_action( 'after_setup_theme', 'digital_marketer_content_width', 0 );

/**
 * Register widget area.
 *
 * @link https://developer.wordpress.org/themes/functionality/sidebars/#registering-a-sidebar
 */
function digital_marketer_widgets_init() {
	register_sidebar(
		array(
			'name'          => esc_html__( 'Sidebar', 'digital-marketer' ),
			'id'            => 'sidebar-1',
			'description'   => esc_html__( 'Add widgets here.', 'digital-marketer' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 1', 'digital-marketer' ),
			'id'            => 'footer-1',
			'description'   => esc_html__( 'Add widgets here.', 'digital-marketer' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 2', 'digital-marketer' ),
			'id'            => 'footer-2',
			'description'   => esc_html__( 'Add widgets here.', 'digital-marketer' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 3', 'digital-marketer' ),
			'id'            => 'footer-3',
			'description'   => esc_html__( 'Add widgets here.', 'digital-marketer' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);
}
add_action( 'widgets_init', 'digital_marketer_widgets_init' );


function digital_marketer_social_menu()
    {
        if (has_nav_menu('social-menu')) :
            wp_nav_menu(array(
                'theme_location' => 'social-menu',
                'container' => 'ul',
                'menu_class' => 'social-menu menu',
                'menu_id'  => 'menu-social',
            ));
        endif;
    }

/**
 * Enqueue scripts and styles.
 */
function digital_marketer_scripts() {

	// Load fonts locally
	require_once get_theme_file_path('revolution/inc/wptt-webfont-loader.php');

	$digital_marketer_font_families = array(
		'Montserrat:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900',
	);
	
	$digital_marketer_fonts_url = add_query_arg( array(
		'family' => implode( '&family=', $digital_marketer_font_families ),
		'display' => 'swap',
	), 'https://fonts.googleapis.com/css2' );

	wp_enqueue_style('digital-marketer-google-fonts', wptt_get_webfont_url(esc_url_raw($digital_marketer_fonts_url)), array(), '1.0.0');
	
	// Font Awesome CSS
	wp_enqueue_style('font-awesome-6', get_template_directory_uri() . '/revolution/assets/vendors/font-awesome-6/css/all.min.css', array(), '6.7.2');

	wp_enqueue_style('owl.carousel.style', get_template_directory_uri() . '/revolution/assets/css/owl.carousel.css', array());
	
	wp_enqueue_style( 'digital-marketer-style', get_stylesheet_uri(), array(), DIGITAL_MARKETER_VERSION );

	require get_parent_theme_file_path( '/custom-style.php' );
	wp_add_inline_style( 'digital-marketer-style',$digital_marketer_custom_css );

	wp_style_add_data('digital-marketer-style', 'rtl', 'replace');

	wp_enqueue_script( 'digital-marketer-navigation', get_template_directory_uri() . '/js/navigation.js', array(), DIGITAL_MARKETER_VERSION, true );

	wp_enqueue_script( 'owl.carousel.jquery', get_template_directory_uri() . '/revolution/assets/js/owl.carousel.js', array(), DIGITAL_MARKETER_VERSION, true );

	wp_enqueue_script( 'digital-marketer-custom-js', get_template_directory_uri() . '/revolution/assets/js/custom.js', array('jquery'), DIGITAL_MARKETER_VERSION, true );

	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}
}
add_action( 'wp_enqueue_scripts', 'digital_marketer_scripts' );

if (!function_exists('digital_marketer_related_post')) :
    /**
     * Display related posts from same category
     *
     */

    function digital_marketer_related_post($post_id){        
        $categories = get_the_category($post_id);
        if ($categories) {
            $category_ids = array();
            $category = get_category($category_ids);
            $categories = get_the_category($post_id);
            foreach ($categories as $category) {
                $category_ids[] = $category->term_id;
            }
            $count = $category->category_count;
            if ($count > 1) { ?>

         	<?php
		$digital_marketer_related_post_wrap = absint(get_theme_mod('digital_marketer_enable_related_post', 1));
		if($digital_marketer_related_post_wrap == 1){ ?>
                <div class="related-post">
                    
                    <h2 class="post-title"><?php esc_html_e(get_theme_mod('digital_marketer_related_post_text', __('Related Post', 'digital-marketer'))); ?></h2>
                    <?php
                    $digital_marketer_cat_post_args = array(
                        'category__in' => $category_ids,
                        'post__not_in' => array($post_id),
                        'post_type' => 'post',
                        'posts_per_page' =>  get_theme_mod( 'digital_marketer_related_post_count', '3' ),
                        'post_status' => 'publish',
						'orderby'           => 'rand',
                        'ignore_sticky_posts' => true
                    );
                    $digital_marketer_featured_query = new WP_Query($digital_marketer_cat_post_args);
                    ?>
                    <div class="rel-post-wrap">
                        <?php
                        if ($digital_marketer_featured_query->have_posts()) :

                        while ($digital_marketer_featured_query->have_posts()) : $digital_marketer_featured_query->the_post();
                            ?>

							<div class="card-item rel-card-item">
								<div class="card-content">
									<?php if ( has_post_thumbnail() ) { ?>
										<div class="card-media">
											<?php digital_marketer_post_thumbnail(); ?>
										</div>
									<?php } else {
										// Fallback default image
										$digital_marketer_default_post_thumbnail = get_template_directory_uri() . '/revolution/assets/image/portfolio4.png';
										echo '<img class="default-post-img" src="' . esc_url( $digital_marketer_default_post_thumbnail ) . '" alt="' . esc_attr( get_the_title() ) . '">';
									} ?>
									<div class="entry-title">
										<h3>
											<a href="<?php the_permalink() ?>">
												<?php the_title(); ?>
											</a>
										</h3>
									</div>
									<div class="entry-meta">
										<?php
										digital_marketer_posted_on();
										digital_marketer_posted_by();
										?>
									</div>
								</div>
							</div>
                        <?php
                        endwhile;
                        ?>
                <?php
                endif;
                wp_reset_postdata();
                ?>
                </div>
                <?php } ?>
                <?php
            }
        }
    }
endif;
add_action('digital_marketer_related_posts', 'digital_marketer_related_post', 10, 1);

function digital_marketer_sanitize_choices( $input, $setting ) {
    global $wp_customize; 
    $control = $wp_customize->get_control( $setting->id ); 
    if ( array_key_exists( $input, $control->choices ) ) {
        return $input;
    } else {
        return $setting->default;
    }
}

//Excerpt 
function digital_marketer_excerpt_function($excerpt_count = 35) {
    $excerpt = get_the_excerpt();
    $text_excerpt = wp_strip_all_tags($excerpt);
    $excerpt_limit = (int) get_theme_mod('digital_marketer_excerpt_limit', $excerpt_count);
    $words = preg_split('/\s+/', $text_excerpt); 
    $trimmed_words = array_slice($words, 0, $excerpt_limit);
    $theme_excerpt = implode(' ', $trimmed_words);

    return $theme_excerpt;
}

// Add admin notice
function digital_marketer_admin_notice() { 
    global $pagenow;
    $digital_marketer_theme_args      = wp_get_theme();
    $digital_marketer_meta            = get_option( 'digital_marketer_admin_notice' );
    $name            = $digital_marketer_theme_args->__get( 'Name' );
    $digital_marketer_current_screen  = get_current_screen();

    if( !$digital_marketer_meta ){
	    if( is_network_admin() ){
	        return;
	    }

	    if( ! current_user_can( 'manage_options' ) ){
	        return;
	    } 
		
		if( $digital_marketer_current_screen->base !== 'appearance_page_digital_marketer_guide' && 
            $digital_marketer_current_screen->base !== 'toplevel_page_digitalmarketer-demoimport' ) { ?>

            <div class="notice notice-success digital-marketer-welcome-notice">
                <p class="digital-marketer-dismiss-link">
                    <strong>
                        <a href="<?php echo esc_url( add_query_arg( 'digital_marketer_admin_notice', '1' ) ); ?>">
                            <?php esc_html_e( 'Dismiss', 'digital-marketer' ); ?>
                        </a>
                    </strong>
                </p>

                <div class="digital-marketer-welcome-notice-wrap">
                    <h2 class="digital-marketer-notice-title">
                        <span class="dashicons dashicons-admin-home"></span> 
                        <?php 
                            $digital_marketer_theme_name = wp_get_theme()->get( 'Name' );
                            /* translators: %s!: Theme Name. */
                            echo esc_html( sprintf( __( 'Welcome to the free theme: %s!', 'digital-marketer' ), $digital_marketer_theme_name ) );
                        ?>
                    </h2>
                    <p class="digital-marketer-notice-desc">
                        <?php esc_html_e( 'Get started by exploring the features of your new theme. Customize your design, add your content, and create a site that fits your vision.', 'digital-marketer' ); ?>
                    </p>

                    <div class="digital-marketer-welcome-info">
                        <div class="digital-marketer-welcome-thumb">
                            <img src="<?php echo esc_url( get_stylesheet_directory_uri() . '/screenshot.png' ); ?>" alt="<?php esc_attr_e( 'Theme Screenshot', 'digital-marketer' ); ?>">
                        </div>

                        <div class="digital-marketer-welcome-import">
                            <h3><span class="dashicons dashicons-download"></span> <?php esc_html_e( 'Quick Start: Import Demo', 'digital-marketer' ); ?></h3>
                            <p><?php esc_html_e( 'Use the Demo Importer to quickly set up your site with a pre-made layout. Get a complete site in minutes.', 'digital-marketer' ); ?></p>
                            <p><a class="button info-link button-primary" href="<?php echo esc_url( admin_url( 'themes.php?page=digitalmarketer-demoimport' ) ); ?>"><?php esc_html_e( 'Go to Demo Importer', 'digital-marketer' ); ?></a></p>
                        </div>

                        <div class="digital-marketer-welcome-getting-started">
                            <h3><span class="dashicons dashicons-art"></span> <?php esc_html_e( 'Customize Your Theme', 'digital-marketer' ); ?></h3>
                            <p><?php esc_html_e( 'Want to make it truly yours? Explore the Getting Started Guide to personalize your site to suit your needs.', 'digital-marketer' ); ?></p>
                            <p><a class="info-link button" href="<?php echo esc_url( admin_url( 'themes.php?page=digital-marketer-getstart-page' ) ); ?>"><?php esc_html_e( 'View Getting Started Guide', 'digital-marketer' ); ?></a></p>
                        </div>
                    </div>
                </div>
            </div>

            <?php
        }

	}
}

add_action( 'admin_notices', 'digital_marketer_admin_notice' );

if( ! function_exists( 'digital_marketer_update_admin_notice' ) ) :
/**
 * Updating admin notice on dismiss
*/
function digital_marketer_update_admin_notice(){
    if ( isset( $_GET['digital_marketer_admin_notice'] ) && $_GET['digital_marketer_admin_notice'] = '1' ) {
        update_option( 'digital_marketer_admin_notice', true );
    }
}
endif;
add_action( 'admin_init', 'digital_marketer_update_admin_notice' );


add_action('after_switch_theme', 'digital_marketer_setup_options');
function digital_marketer_setup_options () {
    update_option('digital_marketer_admin_notice', FALSE );
}

/**
 * Checkbox sanitization callback example.
 *
 * Sanitization callback for 'checkbox' type controls. This callback sanitizes `$checked`
 * as a boolean value, either TRUE or FALSE.
 */
function digital_marketer_sanitize_checkbox($checked)
{
    // Boolean check.
    return ((isset($checked) && true == $checked) ? true : false);
}

/**
 * Implement the Custom Header feature.
 */
require get_template_directory() . '/revolution/inc/custom-header.php';

/**
 * Custom template tags for this theme.
 */
require get_template_directory() . '/revolution/inc/template-tags.php';

/**
 * Functions which enhance the theme by hooking into WordPress.
 */
require get_template_directory() . '/revolution/inc/template-functions.php';

/**
 * Customizer additions.
 */
require get_template_directory() . '/revolution/inc/customizer.php';

/**
 * Load Jetpack compatibility file.
 */
if ( defined( 'JETPACK__VERSION' ) ) {
	require get_template_directory() . '/revolution/inc/jetpack.php';

}

/**
 * Breadcrumb File.
 */
require get_template_directory() . '/revolution/inc/breadcrumbs.php';

/**
 * Custom typography options for this theme.
 */
require get_template_directory() . '/revolution/inc/typography-options.php';

//////////////////////////////////////////////   Function for Translation Error   //////////////////////////////////////////////////////
function digital_marketer_enqueue_function() {

	/**
	* GET START.
	*/
	require get_template_directory() . '/getstarted/digital_marketer_about_page.php';

	/**
	* DEMO IMPORT.
	*/
	require get_template_directory() . '/demo-import/digital_marketer_config_file.php';

	define('DIGITAL_MARKETER_FREE_SUPPORT',__('https://wordpress.org/support/theme/digital-marketer/','digital-marketer'));
	define('DIGITAL_MARKETER_PRO_SUPPORT',__('https://www.revolutionwp.com/pages/community/','digital-marketer'));
	define('DIGITAL_MARKETER_REVIEW',__('https://wordpress.org/support/theme/digital-marketer/reviews/#new-post','digital-marketer'));
	define('DIGITAL_MARKETER_BUY_NOW',__('https://www.revolutionwp.com/products/digital-marketing-wordpress-theme','digital-marketer'));
	define('DIGITAL_MARKETER_LIVE_DEMO',__('https://demo.revolutionwp.com/digital-marketer-pro/','digital-marketer'));
	define('DIGITAL_MARKETER_PRO_DOC',__('https://demo.revolutionwp.com/wpdocs/digital-marketer-pro/','digital-marketer'));
	define('DIGITAL_MARKETER_LITE_DOC',__('https://demo.revolutionwp.com/wpdocs/digital-marketer-free','digital-marketer'));

}
add_action( 'after_setup_theme', 'digital_marketer_enqueue_function' );

function digital_marketer_remove_customize_register() {
    global $wp_customize;

    $wp_customize->remove_setting( 'display_header_text' );
    $wp_customize->remove_control( 'display_header_text' );

}

add_action( 'customize_register', 'digital_marketer_remove_customize_register', 11 );


/**
 * WooCommerce custom filters
 */
add_filter('loop_shop_columns', 'digital_marketer_loop_columns');

if (!function_exists('digital_marketer_loop_columns')) {

	function digital_marketer_loop_columns() {

		$digital_marketer_columns = get_theme_mod( 'digital_marketer_per_columns', 3 );

		return $digital_marketer_columns;
	}
}

/************************************************************************************/

add_filter( 'loop_shop_per_page', 'digital_marketer_per_page', 20 );

function digital_marketer_per_page( $digital_marketer_cols ) {

  	$digital_marketer_cols = get_theme_mod( 'digital_marketer_product_per_page', 9 );

	return $digital_marketer_cols;
}

/************************************************************************************/

add_filter( 'woocommerce_output_related_products_args', 'digital_marketer_products_args' );

function digital_marketer_products_args( $args ) {

    $args['posts_per_page'] = get_theme_mod( 'custom_related_products_number', 6 );

    $args['columns'] = get_theme_mod( 'custom_related_products_number_per_row', 3 );

    return $args;
}

/************************************************************************************/

/**
 * Custom logo
 */

function digital_marketer_custom_css() {
?>
	<style type="text/css" id="custom-theme-colors" >
        :root {
           
            --digital_marketer_logo_width: <?php echo absint(get_theme_mod('digital_marketer_logo_width')); ?> ;   
        }
        .site-branding img {
            max-width:<?php echo esc_html(get_theme_mod('digital_marketer_logo_width')); ?>px ;    
        }         
	</style>
<?php
}
add_action( 'wp_head', 'digital_marketer_custom_css' );


function get_changelog_from_readme() {
    $file_path = get_template_directory() . '/readme.txt'; // Adjust path if necessary

    if (file_exists($file_path)) {
        $content = file_get_contents($file_path);

        // Extract changelog section
        $changelog_start = strpos($content, "== Changelog ==");
        $changelog = substr($content, $changelog_start);

        // Split changelog into versions
        preg_match_all('/\*\s([\d\.]+)\s-\s(.+?)\n((?:\t-\s.+?\n)+)/', $changelog, $matches, PREG_SET_ORDER);
        
        return $matches;
    }
    return [];
}